Content Live

Key Concepts

In this page we’ll break down some of the key concepts and terms associated with the REST API: Routes & Endpoints, Requests, Responses, Schema, and Controller Classes. Each of these concepts play a crucial role in understanding, using, and extending the WordPress REST API, and each is explored in greater depth within this handbook.

Routes & Endpoints

In the context of the WordPress REST API a route is a URI which can be mapped to different HTTP methods. The mapping of an individual HTTP method to a route is known as an endpoint.

As an example, if we make a GET request to the URI http://oursite.com/wp-json/ we are returned a JSON response showing what routes are available, and what endpoints are available within each route.

/wp-json/ is a route, and when that route receives a GET request then that request is handled by the endpoint which displays what is known as the index for the WordPress REST API.

The route wp-json/wp/v2/posts by contrast has a GET endpoint which returns a list of posts, but also a POST endpoint which accepts authenticated requests to create new posts.

We will learn how to register our own routes and endpoints in the following sections.

If you are using non-pretty permalinks, you should pass the REST API route as a query string parameter. The route http://oursite.com/wp-json/ in the example above would hence be http://oursite.com/?rest_route=/.

If you get a 404 error when trying to access http://oursite.com/wp-json/, consider enabling pretty permalinks or try using the rest_route parameter instead.

Requests

A REST API request is represented within WordPress by an instance of the WP_REST_Request class, which is used to store and retrieve information for the current request. A WP_REST_Request object is automatically generated when you make an HTTP request to a registered API route.

The data specified in this object (derived from the route URI or the JSON payload sent as a part of the request) determines what response you will get back out of the API.

Requests are usually submitted remotely via HTTP but may also be made internally from PHP within WordPress plugin or theme code. There are a lot of neat things you can do using this class, detailed further elsewhere in the handbook.

Responses

Responses are the data you get back from the API. The WP_REST_Response class provides a way to interact with the response data returned by endpoints. Responses return the requested data, or can also be used to return errors if something goes wrong while fulfilling the request.

Schema

Each endpoint requires a particular structure of input data, and returns data using a defined and predictable structure. Those data structures are defined in the API Schema.

The schema structures API data and provides a comprehensive list of all of the properties the API can return and which input parameters it can accept.

Well-defined schema also provides one layer of security within the API, as it enables us to validate and sanitize the requests being made to the API. The Schema section explores this large topic further.

Controller Classes

Controller classes unify and coordinate all these various moving parts within a REST API response cycle. With a controller class you can manage the registration of routes & endpoints, handle requests, utilize schema, and generate API responses.

A single class usually contains all of the logic for a given route, and a given route usually represents a specific type of data object within your WordPress site (like a custom post type or taxonomy).

REST API Handbook

The WordPress REST API provides an interface for applications to interact with your WordPress site by sending and receiving data as JSON (JavaScript Object Notation) objects. It is the foundation of the WordPress Block Editor, and can likewise enable your theme, plugin or custom application to present new, powerful interfaces for managing and publishing your site content.

Using the WordPress REST API you can create a plugin to provide an entirely new admin experience for WordPress, build a brand new interactive front-end experience, or bring your WordPress content into completely separate applications.

The REST API is a developer-oriented feature of WordPress. It provides data access to the content of your site, and implements the same authentication restrictions — content that is public on your site is generally publicly accessible via the REST API, while private content, password-protected content, internal users, custom post types, and metadata is only available with authentication or if you specifically set it to be so. If you are not a developer, the most important thing to understand about the API is that it enables the block editor and modern plugin interfaces without compromising the security or privacy of your site.

What Is A REST API?

An API is an Application Programming Interface. REST, standing for “REpresentational State Transfer,” is a set of concepts for modeling and accessing your application’s data as interrelated objects and collections. The WordPress REST API provides REST endpoints (URLs) representing the posts, pages, taxonomies, and other built-in WordPress data types. Your application can send and receive JSON data to these endpoints to query, modify and create content on your site. JSON is an open standard data format that is lightweight and human-readable, and looks like Objects do in JavaScript. When you request content from or send content to the API, the response will also be returned in JSON. Because JSON is widely supported in many programming languages, developers can build WordPress applications in client-side JavaScript (like the block editor), as mobile apps, or as desktop or command line tools.

The REST API is just one of many APIs provided by WordPress. You can find the documentation on these additional APIs here.

Using the WordPress REST API

WordPress already provides a rich set of tools and interfaces for building sites, and you should not feel pressured to use the REST API if your site is already working the way you expect. You do not need to use the REST API to build a WordPress theme or plugin.

However, if you do wish to write your theme, plugin, or external application as a client-side JavaScript application, or a standalone program in a language other than PHP, then your application will need a structured way to access content within your WordPress site. Any programming language which can make HTTP requests and interpret JSON can use the REST API to interact with WordPress, from PHP, Node.js, Go, and Java, to Swift, Kotlin, and beyond.

Even if you’re using vanilla JavaScript or jQuery within a theme or plugin the REST API provides a more predictable and structured way to interact with your site’s content than admin-ajax, enabling you to spend less time accessing the data you need and more time creating better user experiences.

If you want a structured, extensible, and simple way to get data in and out of WordPress, you probably want to use the REST API.

For all of its simplicity the REST API can feel quite complex at first, so in this handbook we will attempt to break it down into smaller components to explain each part of the full puzzle.

Next Steps

Familiarize yourself with the key technical concepts behind how the REST API functions.

Learn more about how to interact with API resources and query for specific data in the Using the REST API section.

Once you’re comfortable with the default workings of the default routes and methods, discover how to add new data to the API or enhance and manipulate existing response objects in the Extending the REST API section.

For a comprehensive overview of the resources and routes available by default, review the API reference.

Requests

Overview

While the WordPress REST API may be called internally within other WordPress code via PHP, the REST API is designed to be used remotely over HTTP. HTTP is the foundation for communication of data over the internet, and any application capable of HTTP requests may make use of the WordPress REST API, whether that application is a client-side JavaScript interface or an application on a remote server running in Python or Java.

The data structure of a request is conveniently handled by the WP_REST_Request class.

WP_REST_Request

This class is one of the three main infrastructure classes introduced in WordPress 4.4. When an HTTP request is made to an endpoint of the API, the API will automatically create an instance of the WP_REST_Request class, matching the provided data. The response object is auto-generated in WP_REST_Server‘s serve_request() method. Once the request is created and authentication is checked, the request is dispatched and our endpoint callbacks begin to be fired. All of the data stored up in the WP_REST_Request object is passed into our callbacks for our registered endpoints. So both our permission_callback and callback are called with the request object being passed in. This enables us to access the various request properties in our callbacks, so that we can tailor our responses to match the desired output.

Request Properties

Request objects have many different properties, each of which can be used in various ways. The main properties are the request method, route, headers, parameters and attributes. Let’s break each of these down into their role in a request. If you were to create a request object yourself it would look like this:

$request = new WP_REST_Request( 'GET', '/my-namespace/v1/examples' );

In the above code sample we are only specifying that the request object method is GET and we should be matching the route /my-namespace/v1/examples which in the context of an entire URL would look like this: https://ourawesomesite.com/wp-json/my-namespace/v1/examples`. The method and route arguments for theWP_REST_Request` constructor are used to map the request to the desired endpoint. If the request is made to an endpoint that is not registered then a helpful 404 error message is returned in the response. Let’s look at the various properties in more depth.

Method

The method property of a request object by default matches the HTTP Request method. The method in most cases will be one of GET, POST, PUT, DELETE, OPTIONS, or HEAD. These methods will be used to match the various endpoints registered to a route. When the API finds a match for the method and route it will fire the callbacks for that endpoint.

The following convention is a best practice for matching HTTP methods: GET for read only tasks, POST for creation, PUT for updating, and DELETE for deleting. The request method acts as an indicator for the expected functionality of your endpoints. When you make a GET request to a route, you should expect to be returned read only data.

Route

The route for a request, by default, will match the server environment variable for path info; $_SERVER['PATH_INFO']. When you make an HTTP request to a route of the WordPress REST API, the generated WP_REST_Request object will be made to match that path, which will hopefully then be matched to a valid endpoint. In short the route for a request is where you want to target your request in the API.

If we had registered a books endpoint, using GET, it might live at `https://ourawesomesite.com/wp-json/my-namespace/v1/books`. If we went to that URL in our browser, we would see our collection of books represented in JSON. WordPress will automatically generate the request object for us and handle all of the routing to match endpoints. So since we don’t really have to worry about the routing ourselves understanding how to pass extra data we want in our requests is a much more important thing to understand.

Headers

HTTP Request headers are simply just extra data about our HTTP request. Request headers can specify caching policy, what our request content is, where the request is coming from and many other things. Request headers do not necessarily interact with our endpoints directly, but the information in the headers helps WordPress know what to do. To pass in data that we want our endpoints to interact with we want to use parameters.

Parameters

When making requests to the WordPress REST API, most of the additional data passed in will take on the form of parameters. What are parameters? There are four different types in the context of the API. There are route parameters, query parameters, body parameters, and file parameters. Let’s take a look at each one a bit more in depth.

URL Params

URL parameters are automatically generated in a WP_REST_Request from the path variables in the requested route. What does that mean? Let’s look at this route, which grabs individual books by id: /my-namespace/v1/books/(?P<id>\d+). The odd looking (?P<id>\d+) is a path variable. The name of the path variable is ‘id‘.

If we were to make a request like GET https://ourawesomesite.com/wp-json/my-namespace/v1/books/5`,5will become the value for ouridpath variable. TheWP_REST_Request` object will automatically take that path variable and store it as a URL parameter. Now inside of our endpoint callbacks we can interact with that URL parameter really easily. Let’s look at an example.

// Register our individual books endpoint.
function prefix_register_book_route() {
    register_rest_route( 'my-namespace/v1', '/books/(?P<id>\d+)', array(
        // Supported methods for this endpoint. WP_REST_Server::READABLE translates to GET.
        'methods' => WP_REST_Server::READABLE,
        // Register the callback for the endpoint.
        'callback' => 'prefix_get_book',
    ) );
}

add_action( 'rest_api_init', 'prefix_register_book_route' );

/**
 * Our registered endpoint callback. Notice how we are passing in $request as an argument.
 * By default, the WP_REST_Server will pass in the matched request object to our callback.
 *
 * @param WP_REST_Request $request The current matched request object.
 */
function prefix_get_book( $request ) {
    // Here we are accessing the path variable 'id' from the $request.
    $book = prefix_get_the_book( $request['id'] );
    return rest_ensure_response( $book );
}

// A simple function that grabs a book title from our books by ID.
function prefix_get_the_book( $id ) {
    $books = array(
        'Design Patterns',
        'Clean Code',
        'Refactoring',
        'Structure and Interpretation of Computer Programs',
    );

    $book = '';
    if ( isset( $books[ $id ] ) ) {
        // Grab the matching book.
        $book = $books[ $id ];
    } else {
        // Error handling.
        return new WP_Error( 'rest_not_found', esc_html__( 'The book does not exist', 'my-text-domain' ), array( 'status' => 404 ) );
    }

    return $book;
}

In the example above we see how path variables are stored as URL parameters in the request object. We can then access those parameters in our endpoint callbacks. The above example is a pretty common use case for using URL params. Adding too many path variables to a route can slow down the matching of routes and it can also over complicate registering endpoints, it is advised to use URL parameters sparingly. If we aren’t supposed to use parameters directly in our URL path, then we need another way to pass in extra information to our request. This is where query and body parameters come in, they will typically do most of the heavy lifting in your API.

Query Params

Query parameters exist in the query string portion of a URI. The query string portion of a URI in https://ourawesomesite.com/wp-json/my-namespace/v1/books?per_page=2&genre=fiction` is?per_page=2&genre=fiction. The query string is started by the '?' character, the different values within the query string are separated by the '&' character. We specified two parameters in our query string;per_pageandgenre. In our endpoint we would want to grab only two books from the fiction genre. We could access those values in a callback like this:$request[‘per_page’], and$request[‘genre’]` ( assuming $request is the name of the argument we are using ). If you are familiar with PHP you have probably used query parameters in your web applications.

In PHP, the query parameters get stored in the superglobal $_GET. It is important to note that you should never directly access any superglobals or server variables in your endpoints. It is always best to work with what is provided by the WP_REST_Request class. Another common method for passing in variables to an endpoint is to use body parameters.

Body Params

Body parameters are key value pairs that are stored in the request body. If you have ever sent a POST request via a <form>, through cURL, or some other method, then you have used body parameters. With body parameters you can pass them as different content types as well. The default Content-Type header for a POST request is x-www-form-urlencoded. When using x-www-form-urlencoded, the parameters are sent like a query string; per_page=2&amp;genre=fiction. An HTML form, by default, will bundle up the various inputs and send a POST request matching the x-www-form-urlencoded pattern.

It is important to note that although the HTTP specification does not prohibit the use of sending body parameters in GET requests, it is encouraged that you do not use body parameters in a GET request. Body parameters can and should be used for POST, PUT, and DELETE requests.

File Params

File parameters in a WP_REST_Request object are stored when the request uses a special content type header; multipart/form-data. The file data can then be accessed from the request object using $request->get_file_params(). The file parameters are equivalent to the PHP superglobal: $_FILES. Remember, do not access the superglobals directly only use what the WP_REST_Request object provides.

In the endpoint callback we could use wp_handle_upload() to then add in the desired files to WordPress’s media uploads directory. The file parameters are only useful for dealing with file data and you should never use them for any other purpose.

Attributes

WP_REST_Request also supports request attributes. The attributes of a request are the attributes registered to the match route. If we made a GET request to my-namespace/v1/books, and then we called $request->get_attributes() inside of our endpoint callback, we would be returned all of the registration options for the my-namespace/v1/books endpoint. If we made a POST request to the same route and our endpoint callback also returned $request->get_attributes(), we would receive a different set of endpoint options registered to the POST endpoint callback.

In the attributes we will get a response containing supported methods, options, whether to show this endpoint in the index, a list of registered arguments for the endpoint, and our registered callbacks. It might look something like this:

{
  "methods": {
    "GET": true
  },
  "accept_json": false,
  "accept_raw": false,
  "show_in_index": true,
  "args": {
    "context": {
      "description": "Scope under which the request is made; determines fields present in response.",
      "type": "string",
      "sanitize_callback": "sanitize_key",
      "validate_callback": "rest_validate_request_arg",
      "enum": [
        "view",
        "embed",
        "edit"
      ],
      "default": "view"
    },
    "page": {
      "description": "Current page of the collection.",
      "type": "integer",
      "default": 1,
      "sanitize_callback": "absint",
      "validate_callback": "rest_validate_request_arg",
      "minimum": 1
    },
    "per_page": {
      "description": "Maximum number of items to be returned in result set.",
      "type": "integer",
      "default": 10,
      "minimum": 1,
      "maximum": 100,
      "sanitize_callback": "absint",
      "validate_callback": "rest_validate_request_arg"
    },
    "search": {
      "description": "Limit results to those matching a string.",
      "type": "string",
      "sanitize_callback": "sanitize_text_field",
      "validate_callback": "rest_validate_request_arg"
    },
    "after": {
      "description": "Limit response to resources published after a given ISO8601 compliant date.",
      "type": "string",
      "format": "date-time",
      "validate_callback": "rest_validate_request_arg"
    },
    "author": {
      "description": "Limit result set to posts assigned to specific authors.",
      "type": "array",
      "default": [],
      "sanitize_callback": "wp_parse_id_list",
      "validate_callback": "rest_validate_request_arg"
    },
    "author_exclude": {
      "description": "Ensure result set excludes posts assigned to specific authors.",
      "type": "array",
      "default": [],
      "sanitize_callback": "wp_parse_id_list",
      "validate_callback": "rest_validate_request_arg"
    },
    "before": {
      "description": "Limit response to resources published before a given ISO8601 compliant date.",
      "type": "string",
      "format": "date-time",
      "validate_callback": "rest_validate_request_arg"
    },
    "exclude": {
      "description": "Ensure result set excludes specific ids.",
      "type": "array",
      "default": [],
      "sanitize_callback": "wp_parse_id_list"
    },
    "include": {
      "description": "Limit result set to specific ids.",
      "type": "array",
      "default": [],
      "sanitize_callback": "wp_parse_id_list"
    },
    "offset": {
      "description": "Offset the result set by a specific number of items.",
      "type": "integer",
      "sanitize_callback": "absint",
      "validate_callback": "rest_validate_request_arg"
    },
    "order": {
      "description": "Order sort attribute ascending or descending.",
      "type": "string",
      "default": "desc",
      "enum": [
        "asc",
        "desc"
      ],
      "validate_callback": "rest_validate_request_arg"
    },
    "orderby": {
      "description": "Sort collection by object attribute.",
      "type": "string",
      "default": "date",
      "enum": [
        "date",
        "relevance",
        "id",
        "include",
        "title",
        "slug"
      ],
      "validate_callback": "rest_validate_request_arg"
    },
    "slug": {
      "description": "Limit result set to posts with a specific slug.",
      "type": "string",
      "validate_callback": "rest_validate_request_arg"
    },
    "status": {
      "default": "publish",
      "description": "Limit result set to posts assigned a specific status; can be comma-delimited list of status types.",
      "enum": [
        "publish",
        "future",
        "draft",
        "pending",
        "private",
        "trash",
        "auto-draft",
        "inherit",
        "any"
      ],
      "sanitize_callback": "sanitize_key",
      "type": "string",
      "validate_callback": [
        {},
        "validate_user_can_query_private_statuses"
      ]
    },
    "filter": {
      "description": "Use WP Query arguments to modify the response; private query vars require appropriate authorization."
    },
    "categories": {
      "description": "Limit result set to all items that have the specified term assigned in the categories taxonomy.",
      "type": "array",
      "sanitize_callback": "wp_parse_id_list",
      "default": []
    },
    "tags": {
      "description": "Limit result set to all items that have the specified term assigned in the tags taxonomy.",
      "type": "array",
      "sanitize_callback": "wp_parse_id_list",
      "default": []
    }
  },
  "callback": [
    {},
    "get_items"
  ],
  "permission_callback": [
    {},
    "get_items_permissions_check"
  ]
}

As you can see we have all of the information we have registered to our endpoint already there, ready to go! The request attributes are typically used at a lower level and are handled by the WP_REST_Server class, however there are cool things that can be done inside of endpoint callbacks, like restricting accepted parameters to match registered arguments.

The WP REST API is designed for you so that you do not have to mess around with any internals, so some of these more advanced methods of interacting with WP_REST_Request are not going to be commonly practiced. The core of using the WP REST API is linked to registering routes and endpoints. Requests are the tool we use to tell the API which endpoint we want to hit. This is most commonly done over HTTP, however we can also use WP_REST_Requests internally.

Internal Requests

The key to making internal requests is using rest_do_request(). All you need to do is pass in a request object and you will be returned a response. Because the request is never served by the WP_REST_Server, the response data is never encoded into json, meaning we have our response object as a PHP object. This is pretty awesome and enables us to do a lot of interesting things. For one, we can create efficient batch endpoints. From a performance perspective, one of the hurdles is minimizing HTTP requests. We can create batch endpoints that will use rest_do_request() to serve all of our requests internally all in one HTTP request. Here is a very simplistic batch endpoint for read only data, so you can see rest_do_request() in action.

// Register our mock batch endpoint.
function prefix_register_batch_route() {
    register_rest_route( 'my-namespace/v1', '/batch', array(
        // Supported methods for this endpoint. WP_REST_Server::READABLE translates to GET.
        'methods' => WP_REST_Server::READABLE,
        // Register the callback for the endpoint.
        'callback' => 'prefix_do_batch_request',
        // Register args for the batch endpoint.
        'args' => prefix_batch_request_parameters(),
    ) );
}

add_action( 'rest_api_init', 'prefix_register_batch_route' );

/**
 * Our registered endpoint callback. Notice how we are passing in $request as an argument.
 * By default, the WP_REST_Server will pass in the matched request object to our callback.
 *
 * @param WP_REST_Request $request The current matched request object.
 */
function prefix_do_batch_request( $request ) {
    // Here we initialize the array that will hold our response data.
    $data = array();
    $data = prefix_handle_batch_requests( $request['requests'] );
    return $data;
}

/**
 * This handles the building of the response for the batch requests we make.
 *
 * @param array $requests An array of data to build WP_REST_Request objects from.
 * @return WP_REST_Response A collection of response data for batch endpoints.
 */
function prefix_handle_batch_requests( $requests ) {
    $data = array();

    // Foreach request specified in the requests param run the endpoint.
    foreach ( $requests as $request_params ) {
        $response = prefix_handle_request( $request_params );
        $key = $request_params['method'] . ' ' . $request_params['route'];
        $data[ $key ] = prefix_prepare_for_collection( $response );
    }

    return rest_ensure_response( $data );
}

/**
 * This handles the building of the response for the batch requests we make.
 *
 * @param array $request_params Data to build a WP_REST_Request object from.
 * @return WP_REST_Response Response data for the request.
 */
function prefix_handle_request( $request_params ) {
    $request = new WP_REST_Request( $request_params['method'], $request_params['route'] );

    // Add specified request parameters into the request.
    if ( isset( $request_params['params'] ) ) {
        foreach ( $request_params['params'] as $param_name => $param_value ) {
            $request->set_param( $param_name, $param_value );
        }
    }
    $response = rest_do_request( $request );
    return $response;
}

/**
 * Prepare a response for inserting into a collection of responses.
 *
 * This is lifted from WP_REST_Controller class in the WP REST API v2 plugin.
 *
 * @param WP_REST_Response $response Response object.
 * @return array Response data, ready for insertion into collection data.
 */
function prefix_prepare_for_collection( $response ) {
    if ( ! ( $response instanceof WP_REST_Response ) ) {
        return $response;
    }

    $data = (array) $response->get_data();
    $server = rest_get_server();

    if ( method_exists( $server, 'get_compact_response_links' ) ) {
        $links = call_user_func( array( $server, 'get_compact_response_links' ), $response );
    } else {
        $links = call_user_func( array( $server, 'get_response_links' ), $response );
    }

    if ( ! empty( $links ) ) {
        $data['_links'] = $links;
    }

    return $data;
}

/**
 * Returns the JSON schema data for our registered parameters.
 *
 * @return array $params A PHP representation of JSON Schema data.
 */
function prefix_batch_request_parameters() {
    $params = array();

    $params['requests'] = array(
        'description'        => esc_html__( 'An array of request objects arguments that can be built into WP_REST_Request instances.', 'my-text-domain' ),
        'type'               => 'array',
        'required'           => true,
        'validate_callback'  => 'prefix_validate_requests',
        'items'              => array(
            array(
                'type' => 'object',
                'properties' => array(
                    'method' => array(
                        'description' => esc_html__( 'HTTP Method of the desired request.', 'my-text-domain' ),
                        'type'        => 'string',
                        'required'    => true,
                        'enum'        => array(
                            'GET',
                            'POST',
                            'PUT',
                            'DELETE',
                            'OPTIONS',
                        ),
                    ),
                    'route' => array(
                        'description' => esc_html__( 'Desired route for the request.', 'my-text-domain' ),
                        'required'    => true,
                        'type'        => 'string',
                        'format'      => 'uri',
                    ),
                    'params' => array(
                        'description' => esc_html__( 'Key value pairs of desired request parameters.', 'my-text-domain' ),
                        'type' => 'object',
                    ),
                ),
            ),
        ),
    );

    return $params;
}

function prefix_validate_requests( $requests, $request, $param_key ) {
    // If requests isn't an array of requests then we don't process the batch.
    if ( ! is_array( $requests ) ) {
        return new WP_Error( 'rest_invald_param', esc_html__( 'The requests parameter must be an array of requests.' ), array( 'status' => 400 ) );
    }

    foreach ( $requests as $request ) {
        // If the method or route is not set then we do not run the requests.
        if ( ! isset( $request['method'] ) || ! isset( $request['route'] ) ) {
            return new WP_Error( 'rest_invald_param', esc_html__( 'You must specify the method and route for each request.' ), array( 'status' => 400 ) );
        }

        if ( isset( $request['params'] ) && ! is_array( $request['params'] ) ) {
            return new WP_Error( 'rest_invald_param', esc_html__( 'You must specify the params for each request as an array of named key value pairs.' ), array( 'status' => 400 ) );
        }
    }

    // This is a black listing approach to data validation.
    return true;
}

That is quite a decent chunk of code that covers a number of topics, but everything centers around what happens in prefix_handle_request(). Here we are passing in an array that tells us a HTTP method, a route, and a set of parameters we want to turn into a request. We then build the request object for the method and route. If any parameters were specified we use the WP_REST_Request::set_param() method to add in the desired parameters. Once our WP_REST_Request is ready to go we use rest_do_request to internally match that endpoint and the response is returned to our batch endpoint response collection. Using a batch endpoint like this can net you huge performance gains, as you will only make one HTTP request to get a response for multiple endpoints. The implementation of this is not necessarily the best and serves as an example; not the only way to do this.

Reference

The WordPress REST API is organized around REST, and is designed to have predictable, resource-oriented URLs and to use HTTP response codes to indicate API errors. The API uses built-in HTTP features, like HTTP authentication and HTTP verbs, which can be understood by off-the-shelf HTTP clients, and supports cross-origin resource sharing to allow you to interact securely with the API from a client-side web application.

The REST API uses JSON exclusively as the request and response format, including error responses. While the REST API does not completely conform to the HAL standard, it does implement HAL’s ._links and ._embedded properties for linking API resources, and is fully discoverable via hyperlinks in the responses.

The REST API provides public data accessible to any client anonymously, as well as private data only available after authentication. Once authenticated the REST API supports most content management actions, allowing you to build alternative dashboards for a site, enhance your plugins with more responsive management tools, or build complex single-page applications.

This API reference provides information on the specific endpoints available through the API, their parameters, and their response data format.

REST API Developer Endpoint Reference

Resource Base Route
Posts /wp/v2/posts
Post Revisions /wp/v2/posts/<id>/revisions
Categories /wp/v2/categories
Tags /wp/v2/tags
Pages /wp/v2/pages
Page Revisions /wp/v2/pages/<id>/revisions
Comments /wp/v2/comments
Taxonomies /wp/v2/taxonomies
Media /wp/v2/media
Users /wp/v2/users
Post Types /wp/v2/types
Post Statuses /wp/v2/statuses
Settings /wp/v2/settings
Themes /wp/v2/themes
Search /wp/v2/search
Block Types /wp/v2/block-types
Blocks /wp/v2/blocks
Block Revisions /wp/v2/blocks/<id>/autosaves/
Block Renderer /wp/v2/block-renderer
Block Directory Items /wp/v2/block-directory/search
Plugins /wp/v2/plugins

A Distributed API

Unlike many other REST APIs, the WordPress REST API is distributed and available individually on each site that supports it. This means there is no singular API root or base to contact; instead, we have a discovery process that allows interacting with sites without prior contact. The API also exposes self-documentation at the index endpoint, or via an OPTIONS request to any endpoint, allowing human- or machine-discovery of endpoint capabilities.

Glossary

New to REST APIs? Get up to speed with phrases used throughout our documentation.

Controller

Model-View-Controller is a standard pattern in software development. If you aren’t already familiar with it, you should do a bit of reading to get up to speed.

Within WP-API, we’ve adopted the controller concept to have a standard pattern for the classes representing our resource endpoints. All resource endpoints extend WP_REST_Controller to ensure they implement common methods.

HEAD, GET, POST, PUT, and DELETE Requests

These “HTTP verbs” represent the type of action a HTTP client might perform against a resource. For instance, GET requests are used to fetch a Post’s data, whereas DELETE requests are used to delete a Post. They’re collectively called “HTTP verbs” because they’re standardized across the web.

If you’re familiar with WordPress functions, a GET request is the equivalent of wp_remote_get(), and a POST request is the same as wp_remote_post().

HTTP Client

The phrase “HTTP Client” refers to the tool you use to interact with WP-API. You might use Postman (Chrome) or REST Easy (Firefox) to test requests in your browser, or httpie to test requests at the commandline.

WordPress itself provides a HTTP Client in the WP_HTTP class and related functions (e.g. wp_remote_get()). This can be used to access one WordPress site from another.

Resource

A “Resource” is a discrete entity within WordPress. You may know these resources already as Posts, Pages, Comments, Users, Terms, and so on. WP-API permits HTTP clients to perform CRUD operations against resources (CRUD stands for Create, Read, Update, and Delete).

Pragmatically, here’s how you’d typically interact with WP-API resources:

Routes / Endpoints

Endpoints are functions available through the API. This can be things like retrieving the API index, updating a post, or deleting a comment. Endpoints perform a specific function, taking some number of parameters and return data to the client.

A route is the “name” you use to access endpoints, used in the URL. A route can have multiple endpoints associated with it, and which is used depends on the HTTP verb.

For example, with the URL `http://example.com/wp-json/wp/v2/posts/123`:

Note: On sites without pretty permalinks, the route is instead added to the URL as the rest_route parameter. For the above example, the full URL would then be `http://example.com/?rest_route=wp/v2/posts/123`

Schema

A “schema” is a representation of the format for WP-API’s response data. For instance, the Post schema communicates that a request to get a Post will return id, title, content, author, and other fields. Our schemas also indicate the type each field is, provide a human-readable description, and show which contexts the field will be returned in.

Using the REST API

These articles explore the basic structure of the WordPress REST API.

Global Parameters: learn about the global REST API query parameters that apply to every endpoint

Pagination: work with large collections of resources & control how many records you receive from the REST API

Linking & Embedding: understand how to read and modify connections between different objects, and embed related resources such as author and media data in the REST API’s responses

Discovery: determine what REST API resources a site supports, and where they are located

Authentication: authorize your REST API requests so that you can create, update and delete your data

Frequently Asked Questions: see some of the most frequent inquiries about the REST API and learn how to solve common problems

Resources & Utilities

Backbone.js Client: interact with the API from within WP-Admin using Backbone models & collections

Client Libraries: utilities in a variety of programming languages that simplify interacting with the API

Extending the REST API

Guides

Modifying responses: add fields to REST API response objects using register_meta or register_rest_field Adding Endpoints: create custom REST API endpoints for your plugin or application Working with Custom Content Types: learn how to interact with your custom post types and custom taxonomies through the REST API

Resources

Defining your API Schema: define the schema for your REST API resources and their arguments Glossary: get up to speed with phrases used throughout our documentation Routes & Endpoints: dive deeper into the nuances of REST API routes and the endpoints they provide Controller Classes: discover how to structure and extend REST API endpoint controller classes Frequently Asked Questions: see some of the most frequent inquiries about the REST API and learn how to solve common problems

Frequently Asked Questions

This page provides solutions to some common questions and problems that may arise while using the API. If your question is not explained here it may have been answered in the WordPress support forums.

Can I disable the REST API?

You should not disable the REST API; doing so will break WordPress Admin functionality that depends on the API being active. However, you may use a filter to require that API consumers be authenticated, which effectively prevents anonymous external access. See below for more information.

Require Authentication for All Requests

You can require authentication for all REST API requests by adding an is_user_logged_in check to the rest_authentication_errors filter. Note: The incoming callback parameter can be either null, a WP_Error, or a boolean. The type of the parameter indicates the state of authentication:

add_filter( 'rest_authentication_errors', function( $result ) {
    // If a previous authentication check was applied,
    // pass that result along without modification.
    if ( true === $result || is_wp_error( $result ) ) {
        return $result;
    }

    // No authentication has been performed yet.
    // Return an error if user is not logged in.
    if ( ! is_user_logged_in() ) {
        return new WP_Error(
            'rest_not_logged_in',
            __( 'You are not currently logged in.' ),
            array( 'status' => 401 )
        );
    }

    // Our custom authentication check should have no effect
    // on logged-in requests
    return $result;
});

Can I make API requests from PHP within a plugin?

Yes, you can! Use rest_do_request to make API requests internally within other WordPress code:

$request = new WP_REST_Request( 'GET', '/wp/v2/posts' );
// Set one or more request query parameters
$request->set_param( 'per_page', 20 );
$response = rest_do_request( $request );

How do I use the _embed parameter on internal requests?

Setting the _embed param on the request object won’t work.

$request = new WP_REST_Request( 'GET', '/wp/v2/posts' );
$request->set_param( '_embed', 1 );
$response = rest_do_request( $request );

Instead, manually call the WP_REST_Server::response_to_data function.

$request = new WP_REST_Request( 'GET', '/wp/v2/posts' );
$response = rest_do_request( $request );
$data = rest_get_server()->response_to_data( $response, true );
var_dump( $data['_embedded'] );

What happened to the ?filter= query parameter?

When the REST API was merged into WordPress core the ?filter query parameter was removed to prevent future compatibility and maintenance issues. The ability to pass arbitrary WP_Query arguments to the API using a ?filter query parameter was necessary at the genesis of the REST API project, but most API response filtering functionality has been superseded by more robust query parameters like ?categories=, ?slug= and ?per_page=. First-party query parameters should be used whenever possible. However, the rest-filter plugin restores the ability to pass arbitrary ?filter values in API request if needed.

Query parameters are not working

If you find that query parameters such as ?page=2 or ?_embed are not having any effect, your server may not be properly configured to detect them. If you are using Nginx to serve your website, look for a try_files line in your site configuration. If it looks like this:

try_files $uri $uri/ /index.php$args;

change it to this:

try_files $uri $uri/ /index.php$is_args$args;

Adding $is_args (which will print a ? character if query arguments are found) will allow WordPress to properly receive and interpret the query parameters.

Why is Authentication not working?

If you’re finding that you are sending Authentication headers but the request is not being accepted, and you are using a CGI environment, your webserver may be stripping the headers. Please try adding the appropriate configuration below to remedy this.

Apache

Add the following to a configuration file or .htaccess:

<IfModule mod_setenvif>
  SetEnvIf Authorization "(.*)" HTTP_AUTHORIZATION=$1
</IfModule>

Nginx

Add the following to your server configurations fastcgi section:

fastcgi_pass_header Authorization;

Why is the REST API not verifying the incoming Origin header? Does this expose my site to CSRF attacks?

Cross-Origin Resource Sharing (CORS) is a mechanism which allows a website to control which Origins (originating external sites) are allowed to access your site’s data. CORS prevents against a particular type of attack known as Cross-Site Request Forgery, or CSRF. However, WordPress has an existing CSRF protection mechanism which uses nonces. Tightening CORS restrictions would prevent some authentication methods, so the WordPress REST API uses nonces for CSRF protection instead of CORS. Because the WordPress REST API does not verify the Origin header of incoming requests, public REST API endpoints may therefore be accessed from any site. This is an intentional design decision, but if you wish to prevent your site from being accessed from unknown origins you may unhook the default rest_send_cors_headers function from the rest_pre_serve_request filter hook, then hook in your own function to that same filter to specify stricter CORS headers.

Changelog

This document details changes to the WP REST API since its public release in version 4.7.0.

Version 5.6

Version 5.5

Version 5.4

Version 5.3

Version 5.2

Version 5.1

Version 5.0

Version 4.9.8

Version 4.8.1

Version 4.8.0

Version 4.7.4

Version 4.7.3

Version 4.7.2

Version 4.7.1

Rendered Blocks

Schema

The schema defines all the fields that exist within a Rendered Block record. Any response from these endpoints can be expected to contain the fields below unless the `_filter` query parameter is used or the schema field only appears in a specific context.

rendered The rendered block.

JSON data type: string

Context: edit

Create a Rendered Block

Arguments

name Unique registered name for the block.
context Scope under which the request is made; determines fields present in response.

Default: view

One of: edit

attributes Attributes for the block.
post_id ID of the post context.

Definition

POST /wp/v2/block-renderer/<name>

Search Results

Schema

The schema defines all the fields that exist within a search result record. Any response from these endpoints can be expected to contain the fields below unless the `_filter` query parameter is used or the schema field only appears in a specific context.

id Unique identifier for the object.

JSON data type: integer or string

Read only

Context: view, embed

title The title for the object.

JSON data type: string

Read only

Context: view, embed

url URL to the object.

JSON data type: string,
Format: uri

Read only

Context: view, embed

type Object type.

JSON data type: string

Read only

Context: view, embed

One of: post, term, post-format

subtype Object subtype.

JSON data type: string

Read only

Context: view, embed

One of: post, page, category, post_tag

List Search Results

Query this endpoint to retrieve a collection of search results. The response you receive can be controlled and filtered using the URL query parameters below.

Definition

GET /wp/v2/search

Example Request

$ curl https://example.com/wp-json/wp/v2/search

Arguments

context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed

page Current page of the collection.

Default: 1

per_page Maximum number of items to be returned in result set.

Default: 10

search Limit results to those matching a string.
type Limit results to items of an object type.

Default: post

One of: post, term, post-format

subtype Limit results to items of one or more object subtypes.

Default: any

exclude Ensure result set excludes specific IDs.
include Limit result set to specific IDs.

Themes

Schema

The schema defines all the fields that exist within a theme record. Any response from these endpoints can be expected to contain the fields below unless the `_filter` query parameter is used or the schema field only appears in a specific context.

stylesheet The theme’s stylesheet. This uniquely identifies the theme.

JSON data type: string

Read only

Context:

template The theme’s template. If this is a child theme, this refers to the parent theme, otherwise this is the same as the theme’s stylesheet.

JSON data type: string

Read only

Context:

author The theme author.

JSON data type: object

Read only

Context:

author_uri The website of the theme author.

JSON data type: object

Read only

Context:

description A description of the theme.

JSON data type: object

Read only

Context:

is_block_theme Whether the theme is a block-based theme.

JSON data type: boolean

Read only

Context:

name The name of the theme.

JSON data type: object

Read only

Context:

requires_php The minimum PHP version required for the theme to work.

JSON data type: string

Read only

Context:

requires_wp The minimum WordPress version required for the theme to work.

JSON data type: string

Read only

Context:

screenshot The theme’s screenshot URL.

JSON data type: string,
Format: uri

Read only

Context:

tags Tags indicating styles and features of the theme.

JSON data type: object

Read only

Context:

textdomain The theme’s text domain.

JSON data type: string

Read only

Context:

theme_supports Features supported by this theme.

JSON data type: object

Read only

Context:

theme_uri The URI of the theme’s webpage.

JSON data type: object

Read only

Context:

version The theme’s current version.

JSON data type: string

Read only

Context:

status A named status for the theme.

JSON data type: string

Context:

One of: inactive, active

Retrieve a Theme

Definition & Example Request

GET /wp/v2/themes

Query this endpoint to retrieve a specific theme record.

$ curl https://example.com/wp-json/wp/v2/themes

Arguments

status Limit result set to themes assigned one or more statuses.

Retrieve a Theme

Definition & Example Request

GET /wp/v2/themes/<stylesheet>?)

Query this endpoint to retrieve a specific theme record.

$ curl https://example.com/wp-json/wp/v2/themes/<stylesheet>?)

Arguments

stylesheet The theme’s stylesheet. This uniquely identifies the theme.

Block Revisions

Schema

The schema defines all the fields that exist within a Block Revision record. Any response from these endpoints can be expected to contain the fields below unless the `_filter` query parameter is used or the schema field only appears in a specific context.

author The ID for the author of the revision.

JSON data type: integer

Context: view, edit, embed

date The date the revision was published, in the site’s timezone.

JSON data type: string,
Format: datetime (details)

Context: view, edit, embed

date_gmt The date the revision was published, as GMT.

JSON data type: string,
Format: datetime (details)

Context: view, edit

guid The globally unique identifier for the post.

JSON data type: object

Read only

Context: view, edit

id Unique identifier for the revision.

JSON data type: integer

Context: view, edit, embed

modified The date the revision was last modified, in the site’s timezone.

JSON data type: string,
Format: datetime (details)

Context: view, edit

modified_gmt The date the revision was last modified, as GMT.

JSON data type: string,
Format: datetime (details)

Context: view, edit

parent The ID for the parent of the revision.

JSON data type: integer

Context: view, edit, embed

slug An alphanumeric identifier for the revision unique to its type.

JSON data type: string

Context: view, edit, embed

title The title for the post.

JSON data type: object

Context: view, edit, embed

content The content for the post.

JSON data type: object

Context: view, edit

List Block Revisions

Query this endpoint to retrieve a collection of Block Revisions. The response you receive can be controlled and filtered using the URL query parameters below.

Definition

GET /wp/v2/blocks/<parent>/revisions

Example Request

$ curl https://example.com/wp-json/wp/v2/blocks/<parent>/revisions

Arguments

parent The ID for the parent of the revision.
context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

page Current page of the collection.

Default: 1

per_page Maximum number of items to be returned in result set.
search Limit results to those matching a string.
exclude Ensure result set excludes specific IDs.
include Limit result set to specific IDs.
offset Offset the result set by a specific number of items.
order Order sort attribute ascending or descending.

Default: desc

One of: asc, desc

orderby Sort collection by object attribute.

Default: date

One of: date, id, include, relevance, slug, include_slugs, title

Retrieve a Block Revision

Definition & Example Request

GET /wp/v2/blocks/<parent>/revisions/<id>

Query this endpoint to retrieve a specific Block Revision record.

$ curl https://example.com/wp-json/wp/v2/blocks/<parent>/revisions/<id>

Arguments

parent The ID for the parent of the revision.
id Unique identifier for the revision.
context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

Delete a Block Revision

Arguments

parent The ID for the parent of the revision.
id Unique identifier for the revision.
force Required to be true, as revisions do not support trashing.

Definition

DELETE /wp/v2/blocks/<parent>/revisions/<id>

Example Request

$ curl -X DELETE https://example.com/wp-json/wp/v2/blocks/<parent>/revisions/<id>

Retrieve a Block Revision

Definition & Example Request

GET /wp/v2/blocks/<id>/autosaves

Query this endpoint to retrieve a specific Block Revision record.

$ curl https://example.com/wp-json/wp/v2/blocks/<id>/autosaves

Arguments

parent The ID for the parent of the autosave.
context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

Create a Block Revision

Arguments

parent The ID for the parent of the autosave.
date The date the post was published, in the site’s timezone.
date_gmt The date the post was published, as GMT.
slug An alphanumeric identifier for the post unique to its type.
status A named status for the post.
One of: publish, future, draft, pending, private
password A password to protect access to the content and excerpt.
title The title for the post.
content The content for the post.
meta Meta fields.
template The theme file to use to display the post.

Definition

POST /wp/v2/blocks/<id>/autosaves

Retrieve a Block Revision

Definition & Example Request

GET /wp/v2/blocks/<parent>/autosaves/<id>

Query this endpoint to retrieve a specific Block Revision record.

$ curl https://example.com/wp-json/wp/v2/blocks/<parent>/autosaves/<id>

Arguments

parent The ID for the parent of the autosave.
id The ID for the autosave.
context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

Editor Blocks

Schema

The schema defines all the fields that exist within a Editor Block record. Any response from these endpoints can be expected to contain the fields below unless the `_filter` query parameter is used or the schema field only appears in a specific context.

date The date the post was published, in the site’s timezone.

JSON data type: string or null, Format: datetime (details)

Context: view, edit, embed

date_gmt The date the post was published, as GMT.

JSON data type: string or null, Format: datetime (details)

Context: view, edit

guid The globally unique identifier for the post.

JSON data type: object

Read only

Context: view, edit

id Unique identifier for the post.

JSON data type: integer

Read only

Context: view, edit, embed

link URL to the post.

JSON data type: string, Format: uri

Read only

Context: view, edit, embed

modified The date the post was last modified, in the site’s timezone.

JSON data type: string, Format: datetime (details)

Read only

Context: view, edit

modified_gmt The date the post was last modified, as GMT.

JSON data type: string, Format: datetime (details)

Read only

Context: view, edit

slug An alphanumeric identifier for the post unique to its type.

JSON data type: string

Context: view, edit, embed

status A named status for the post.

JSON data type: string

Context: view, edit

One of: publish, future, draft, pending, private
type Type of post.

JSON data type: string

Read only

Context: view, edit, embed

password A password to protect access to the content and excerpt.

JSON data type: string

Context: edit

title The title for the post.

JSON data type: object

Context: view, edit, embed

content The content for the post.

JSON data type: object

Context: view, edit

meta Meta fields.

JSON data type: object

Context: view, edit

template The theme file to use to display the post.

JSON data type: string

Context: view, edit

List Editor Blocks

Query this endpoint to retrieve a collection of Editor Blocks. The response you receive can be controlled and filtered using the URL query parameters below.

Definition

GET /wp/v2/blocks

Example Request

$ curl https://example.com/wp-json/wp/v2/blocks

Arguments

context
Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit
page
Current page of the collection.

Default: 1

per_page
Maximum number of items to be returned in result set.

Default: 10

search
Limit results to those matching a string.
after
Limit response to posts published after a given ISO8601 compliant date.
modified_after
Limit response to posts modified after a given ISO8601 compliant date.
before
Limit response to posts published before a given ISO8601 compliant date.
modified_before
Limit response to posts modified before a given ISO8601 compliant date.
exclude
Ensure result set excludes specific IDs.
include
Limit result set to specific IDs.
offset
Offset the result set by a specific number of items.
order
Order sort attribute ascending or descending.

Default: desc

One of: asc, desc
orderby
Sort collection by post attribute.

Default: date

One of: author, date, id, include, modified, parent, relevance, slug, include_slugs, title
search_columns
Array of column names to be searched.
slug
Limit result set to posts with one or more specific slugs.
status
Limit result set to posts assigned one or more statuses.

Default: publish

Create a Editor Block

Arguments

date
The date the post was published, in the site’s timezone.
date_gmt
The date the post was published, as GMT.
slug
An alphanumeric identifier for the post unique to its type.
status
A named status for the post. One of: publish, future, draft, pending, private
password
A password to protect access to the content and excerpt.
title
The title for the post.
content
The content for the post.
meta
Meta fields.
template
The theme file to use to display the post.

Definition

POST /wp/v2/blocks

Retrieve a Editor Block

Definition & Example Request

GET /wp/v2/blocks/<id> Query this endpoint to retrieve a specific Editor Block record. $ curl https://example.com/wp-json/wp/v2/blocks/<id>

Arguments

id
Unique identifier for the post.
context
Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit
password
The password for the post if it is password protected.

Update a Editor Block

Arguments

id
Unique identifier for the post.
date
The date the post was published, in the site’s timezone.
date_gmt
The date the post was published, as GMT.
slug
An alphanumeric identifier for the post unique to its type.
status
A named status for the post. One of: publish, future, draft, pending, private
password
A password to protect access to the content and excerpt.
title
The title for the post.
content
The content for the post.
meta
Meta fields.
template
The theme file to use to display the post.

Definition

POST /wp/v2/blocks/<id>

Example Request

Delete a Editor Block

Arguments

id
Unique identifier for the post.
force
Whether to bypass Trash and force deletion.

Definition

DELETE /wp/v2/blocks/<id>

Example Request

$ curl -X DELETE https://example.com/wp-json/wp/v2/blocks/<id>

Block Directory Items

Schema

The schema defines all the fields that exist within a block directory item record. Any response from these endpoints can be expected to contain the fields below unless the `_filter` query parameter is used or the schema field only appears in a specific context.

name The block name, in namespace/block-name format.

JSON data type: string

Context: view

title The block title, in human readable format.

JSON data type: string

Context: view

description A short description of the block, in human readable format.

JSON data type: string

Context: view

id The block slug.

JSON data type: string

Context: view

rating The star rating of the block.

JSON data type: number

Context: view

rating_count The number of ratings.

JSON data type: integer

Context: view

active_installs The number sites that have activated this block.

JSON data type: integer

Context: view

author_block_rating The average rating of blocks published by the same author.

JSON data type: number

Context: view

author_block_count The number of blocks published by the same author.

JSON data type: integer

Context: view

author The WordPress.org username of the block author.

JSON data type: string

Context: view

icon The block icon.

JSON data type: string,
Format: uri

Context: view

last_updated The date when the block was last updated.

JSON data type: string,
Format: datetime (details)

Context: view

humanized_updated The date when the block was last updated, in fuzzy human readable format.

JSON data type: string

Context: view

List Block Directory Items

Query this endpoint to retrieve a collection of block directory items. The response you receive can be controlled and filtered using the URL query parameters below.

Definition

GET /wp/v2/block-directory/search

Example Request

$ curl https://example.com/wp-json/wp/v2/block-directory/search

Arguments

context Scope under which the request is made; determines fields present in response.

Default: view

One of: view

page Current page of the collection.

Default: 1

per_page Maximum number of items to be returned in result set.

Default: 10

term Limit result set to blocks matching the search term.

Required: 1

Block Types

Schema

The schema defines all the fields that exist within a block type record. Any response from these endpoints can be expected to contain the fields below unless the `_filter` query parameter is used or the schema field only appears in a specific context.

api_version Version of block API.

JSON data type: integer

Read only

Context: embed, view, edit

title Title of block type.

JSON data type: string

Read only

Context: embed, view, edit

name Unique name identifying the block type.

JSON data type: string

Read only

Context: embed, view, edit

description Description of block type.

JSON data type: string

Read only

Context: embed, view, edit

icon Icon of block type.

JSON data type: string or null

Read only

Context: embed, view, edit

attributes Block attributes.

JSON data type: object or null

Read only

Context: embed, view, edit

provides_context Context provided by blocks of this type.

JSON data type: object

Read only

Context: embed, view, edit

uses_context Context values inherited by blocks of this type.

JSON data type: array

Read only

Context: embed, view, edit

selectors Custom CSS selectors.

JSON data type: object

Read only

Context: embed, view, edit

supports Block supports.

JSON data type: object

Read only

Context: embed, view, edit

category Block category.

JSON data type: string or null

Read only

Context: embed, view, edit

is_dynamic Is the block dynamically rendered.

JSON data type: boolean

Read only

Context: embed, view, edit

editor_script_handles Editor script handles.

JSON data type: array

Read only

Context: embed, view, edit

script_handles Public facing and editor script handles.

JSON data type: array

Read only

Context: embed, view, edit

view_script_handles Public facing script handles.

JSON data type: array

Read only

Context: embed, view, edit

editor_style_handles Editor style handles.

JSON data type: array

Read only

Context: embed, view, edit

style_handles Public facing and editor style handles.

JSON data type: array

Read only

Context: embed, view, edit

styles Block style variations.

JSON data type: array

Read only

Context: embed, view, edit

variations Block variations.

JSON data type: array

Read only

Context: embed, view, edit

textdomain Public text domain.

JSON data type: string or null

Read only

Context: embed, view, edit

parent Parent blocks.

JSON data type: array or null

Read only

Context: embed, view, edit

ancestor Ancestor blocks.

JSON data type: array or null

Read only

Context: embed, view, edit

keywords Block keywords.

JSON data type: array

Read only

Context: embed, view, edit

example Block example.

JSON data type: object or null

Read only

Context: embed, view, edit

editor_script Editor script handle. DEPRECATED: Use `editor_script_handles` instead.

JSON data type: string or null

Read only

Context: embed, view, edit

script Public facing and editor script handle. DEPRECATED: Use `script_handles` instead.

JSON data type: string or null

Read only

Context: embed, view, edit

view_script Public facing script handle. DEPRECATED: Use `view_script_handles` instead.

JSON data type: string or null

Read only

Context: embed, view, edit

editor_style Editor style handle. DEPRECATED: Use `editor_style_handles` instead.

JSON data type: string or null

Read only

Context: embed, view, edit

style Public facing and editor style handle. DEPRECATED: Use `style_handles` instead.

JSON data type: string or null

Read only

Context: embed, view, edit

Retrieve a Block Type

Definition & Example Request

GET /wp/v2/block-types

Query this endpoint to retrieve a specific block type record.

$ curl https://example.com/wp-json/wp/v2/block-types

Arguments

context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

namespace Block namespace.

Retrieve a Block Type

Definition & Example Request

GET /wp/v2/block-types/<namespace>

Query this endpoint to retrieve a specific block type record.

$ curl https://example.com/wp-json/wp/v2/block-types/<namespace>

Arguments

context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

namespace Block namespace.

Retrieve a Block Type

Definition & Example Request

GET /wp/v2/block-types/<namespace>/<name>

Query this endpoint to retrieve a specific block type record.

$ curl https://example.com/wp-json/wp/v2/block-types/<namespace>/<name>

Arguments

name Block name.
namespace Block namespace.
context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

Plugins

Schema

The schema defines all the fields that exist within a plugin record. Any response from these endpoints can be expected to contain the fields below unless the `_filter` query parameter is used or the schema field only appears in a specific context.

plugin The plugin file.

JSON data type: string

Read only

Context: view, edit, embed

status The plugin activation status.

JSON data type: string

Context: view, edit, embed

One of: inactive, active

name The plugin name.

JSON data type: string

Read only

Context: view, edit, embed

plugin_uri The plugin’s website address.

JSON data type: string,
Format: uri

Read only

Context: view, edit

author The plugin author.

JSON data type: object

Read only

Context: view, edit

author_uri Plugin author’s website address.

JSON data type: string,
Format: uri

Read only

Context: view, edit

description The plugin description.

JSON data type: object

Read only

Context: view, edit

version The plugin version number.

JSON data type: string

Read only

Context: view, edit

network_only Whether the plugin can only be activated network-wide.

JSON data type: boolean

Read only

Context: view, edit, embed

requires_wp Minimum required version of WordPress.

JSON data type: string

Read only

Context: view, edit, embed

requires_php Minimum required version of PHP.

JSON data type: string

Read only

Context: view, edit, embed

textdomain The plugin’s text domain.

JSON data type: string

Read only

Context: view, edit

Retrieve a Plugin

Definition & Example Request

GET /wp/v2/plugins

Query this endpoint to retrieve a specific plugin record.

$ curl https://example.com/wp-json/wp/v2/plugins

Arguments

context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

search Limit results to those matching a string.
status Limits results to plugins with the given status.

Create a Plugin

Arguments

slug WordPress.org plugin directory slug.

Required: 1

status The plugin activation status.

Default: inactive

One of: inactive, active

Definition

POST /wp/v2/plugins

Retrieve a Plugin

Definition & Example Request

GET /wp/v2/plugins/<plugin>?)

Query this endpoint to retrieve a specific plugin record.

$ curl https://example.com/wp-json/wp/v2/plugins/<plugin>?)

Arguments

context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

plugin

Update a Plugin

Arguments

context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

plugin
status The plugin activation status.
One of: inactive, active

Definition

POST /wp/v2/plugins/<plugin>?)

Example Request

Delete a Plugin

Arguments

context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

plugin

Definition

DELETE /wp/v2/plugins/<plugin>?)

Example Request

$ curl -X DELETE https://example.com/wp-json/wp/v2/plugins/<plugin>?)

Application Passwords

Schema

The schema defines all the fields that exist within a application password record. Any response from these endpoints can be expected to contain the fields below unless the `_filter` query parameter is used or the schema field only appears in a specific context.

uuid The unique identifier for the application password.

JSON data type: string,
Format: uuid

Read only

Context: view, edit, embed

app_id A UUID provided by the application to uniquely identify it. It is recommended to use an UUID v5 with the URL or DNS namespace.

JSON data type: string,
Format: uuid

Context: view, edit, embed

name The name of the application password.

JSON data type: string

Context: view, edit, embed

password The generated password. Only available after adding an application.

JSON data type: string

Read only

Context: edit

created The GMT date the application password was created.

JSON data type: string,
Format: datetime (details)

Read only

Context: view, edit

last_used The GMT date the application password was last used.

JSON data type: string or null,
Format: datetime (details)

Read only

Context: view, edit

last_ip The IP address the application password was last used by.

JSON data type: string or null,
Format: ip

Read only

Context: view, edit

Retrieve a Application Password

Definition & Example Request

GET /wp/v2/users/<user_id>)/application-passwords

Query this endpoint to retrieve a specific application password record.

$ curl https://example.com/wp-json/wp/v2/users/<user_id>)/application-passwords

Arguments

context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

Create a Application Password

Arguments

app_id A UUID provided by the application to uniquely identify it. It is recommended to use an UUID v5 with the URL or DNS namespace.
name The name of the application password.

Required: 1

Definition

POST /wp/v2/users/<user_id>)/application-passwords

Delete a Application Password

There are no arguments for this endpoint.

Definition

DELETE /wp/v2/users/<user_id>)/application-passwords

Example Request

$ curl -X DELETE https://example.com/wp-json/wp/v2/users/<user_id>)/application-passwords

Retrieve a Application Password

Definition & Example Request

GET /wp/v2/users/<user_id>)/application-passwords/introspect

Query this endpoint to retrieve a specific application password record.

$ curl https://example.com/wp-json/wp/v2/users/<user_id>)/application-passwords/introspect

Arguments

context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

Retrieve a Application Password

Definition & Example Request

GET /wp/v2/users/<user_id>)/application-passwords/<uuid>

Query this endpoint to retrieve a specific application password record.

$ curl https://example.com/wp-json/wp/v2/users/<user_id>)/application-passwords/<uuid>

Arguments

context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

Update a Application Password

Arguments

app_id A UUID provided by the application to uniquely identify it. It is recommended to use an UUID v5 with the URL or DNS namespace.
name The name of the application password.

Definition

POST /wp/v2/users/<user_id>)/application-passwords/<uuid>

Example Request

Delete a Application Password

There are no arguments for this endpoint.

Definition

DELETE /wp/v2/users/<user_id>)/application-passwords/<uuid>

Example Request

$ curl -X DELETE https://example.com/wp-json/wp/v2/users/<user_id>)/application-passwords/<uuid>

Block Pattern Categories

Schema

The schema defines all the fields that exist within a block pattern category record. Any response from these endpoints can be expected to contain the fields below unless the `_filter` query parameter is used or the schema field only appears in a specific context.

name The category name.

JSON data type: string

Read only

Context: view, edit, embed

label The category label, in human readable format.

JSON data type: string

Read only

Context: view, edit, embed

description The category description, in human readable format.

JSON data type: string

Read only

Context: view, edit, embed

Retrieve a Block Pattern Category

Definition & Example Request

GET /wp/v2/block-patterns/categories

Query this endpoint to retrieve a specific block pattern category record.

$ curl https://example.com/wp-json/wp/v2/block-patterns/categories

There are no arguments for this endpoint.

Block Patterns

Schema

The schema defines all the fields that exist within a block pattern record. Any response from these endpoints can be expected to contain the fields below unless the `_filter` query parameter is used or the schema field only appears in a specific context.

name The pattern name.

JSON data type: string

Read only

Context: view, edit, embed

title The pattern title, in human readable format.

JSON data type: string

Read only

Context: view, edit, embed

content The pattern content.

JSON data type: string

Read only

Context: view, edit, embed

description The pattern detailed description.

JSON data type: string

Read only

Context: view, edit, embed

viewport_width The pattern viewport width for inserter preview.

JSON data type: number

Read only

Context: view, edit, embed

inserter Determines whether the pattern is visible in inserter.

JSON data type: boolean

Read only

Context: view, edit, embed

categories The pattern category slugs.

JSON data type: array

Read only

Context: view, edit, embed

keywords The pattern keywords.

JSON data type: array

Read only

Context: view, edit, embed

block_types Block types that the pattern is intended to be used with.

JSON data type: array

Read only

Context: view, edit, embed

post_types An array of post types that the pattern is restricted to be used with.

JSON data type: array

Read only

Context: view, edit, embed

template_types An array of template types where the pattern fits.

JSON data type: array

Read only

Context: view, edit, embed

source Where the pattern comes from e.g. core

JSON data type: string

Read only

Context: view, edit, embed

One of: core, plugin, theme, pattern-directory/core, pattern-directory/theme, pattern-directory/featured

Retrieve a Block Pattern

Definition & Example Request

GET /wp/v2/block-patterns/patterns

Query this endpoint to retrieve a specific block pattern record.

$ curl https://example.com/wp-json/wp/v2/block-patterns/patterns

There are no arguments for this endpoint.

Menu Locations

Schema

The schema defines all the fields that exist within a menu location record. Any response from these endpoints can be expected to contain the fields below unless the `_filter` query parameter is used or the schema field only appears in a specific context.

name The name of the menu location.

JSON data type: string

Read only

Context: embed, view, edit

description The description of the menu location.

JSON data type: string

Read only

Context: embed, view, edit

menu The ID of the assigned menu.

JSON data type: integer

Read only

Context: embed, view, edit

Retrieve a Menu Location

Definition & Example Request

GET /wp/v2/menu-locations

Query this endpoint to retrieve a specific menu location record.

$ curl https://example.com/wp-json/wp/v2/menu-locations

Arguments

context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

Retrieve a Menu Location

Definition & Example Request

GET /wp/v2/menu-locations/<location>

Query this endpoint to retrieve a specific menu location record.

$ curl https://example.com/wp-json/wp/v2/menu-locations/<location>

Arguments

location An alphanumeric identifier for the menu location.
context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

Nav_Menu_Item Revisions

Schema

The schema defines all the fields that exist within a nav_menu_item revision record. Any response from these endpoints can be expected to contain the fields below unless the `_filter` query parameter is used or the schema field only appears in a specific context.

author The ID for the author of the revision.

JSON data type: integer

Context: view, edit, embed

date The date the revision was published, in the site’s timezone.

JSON data type: string,
Format: datetime (details)

Context: view, edit, embed

date_gmt The date the revision was published, as GMT.

JSON data type: string,
Format: datetime (details)

Context: view, edit

guid GUID for the revision, as it exists in the database.

JSON data type: string

Context: view, edit

id Unique identifier for the revision.

JSON data type: integer

Context: view, edit, embed

modified The date the revision was last modified, in the site’s timezone.

JSON data type: string,
Format: datetime (details)

Context: view, edit

modified_gmt The date the revision was last modified, as GMT.

JSON data type: string,
Format: datetime (details)

Context: view, edit

parent The ID for the parent of the revision.

JSON data type: integer

Context: view, edit, embed

slug An alphanumeric identifier for the revision unique to its type.

JSON data type: string

Context: view, edit, embed

title The title for the object.

JSON data type: string or object

Context: view, edit, embed

Retrieve a Nav_Menu_Item Revision

Definition & Example Request

GET /wp/v2/menu-items/<id>/autosaves

Query this endpoint to retrieve a specific nav_menu_item revision record.

$ curl https://example.com/wp-json/wp/v2/menu-items/<id>/autosaves

Arguments

parent The ID for the parent of the autosave.
context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

Create a Nav_Menu_Item Revision

Arguments

parent The ID for the parent of the object.
title The title for the object.
type The family of objects originally represented, such as “post_type” or “taxonomy”.
One of: taxonomy, post_type, post_type_archive, custom
status A named status for the object.
One of: publish, future, draft, pending, private
attr_title Text for the title attribute of the link element for this menu item.
classes Class names for the link element of this menu item.
description The description of this menu item.
menu_order The DB ID of the nav_menu_item that is this item’s menu parent, if any, otherwise 0.
object The type of object originally represented, such as “category”, “post”, or “attachment”.
object_id The database ID of the original object this menu item represents, for example the ID for posts or the term_id for categories.
target The target attribute of the link element for this menu item.
One of: _blank,
url The URL to which this menu item points.
xfn The XFN relationship expressed in the link of this menu item.
menus The terms assigned to the object in the nav_menu taxonomy.
meta Meta fields.

Definition

POST /wp/v2/menu-items/<id>/autosaves

Retrieve a Nav_Menu_Item Revision

Definition & Example Request

GET /wp/v2/menu-items/<parent>/autosaves/<id>

Query this endpoint to retrieve a specific nav_menu_item revision record.

$ curl https://example.com/wp-json/wp/v2/menu-items/<parent>/autosaves/<id>

Arguments

parent The ID for the parent of the autosave.
id The ID for the autosave.
context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

Nav_Menu_Items

Schema

The schema defines all the fields that exist within a nav_menu_item record. Any response from these endpoints can be expected to contain the fields below unless the `_filter` query parameter is used or the schema field only appears in a specific context.

title The title for the object.

JSON data type: string or object

Context: view, edit, embed

id Unique identifier for the object.

JSON data type: integer

Read only

Context: view, edit, embed

type_label The singular label used to describe this type of menu item.

JSON data type: string

Read only

Context: view, edit, embed

type The family of objects originally represented, such as “post_type” or “taxonomy”.

JSON data type: string

Context: view, edit, embed

One of: taxonomy, post_type, post_type_archive, custom

status A named status for the object.

JSON data type: string

Context: view, edit, embed

One of: publish, future, draft, pending, private

parent The ID for the parent of the object.

JSON data type: integer

Context: view, edit, embed

attr_title Text for the title attribute of the link element for this menu item.

JSON data type: string

Context: view, edit, embed

classes Class names for the link element of this menu item.

JSON data type: array

Context: view, edit, embed

description The description of this menu item.

JSON data type: string

Context: view, edit, embed

menu_order The DB ID of the nav_menu_item that is this item’s menu parent, if any, otherwise 0.

JSON data type: integer

Context: view, edit, embed

object The type of object originally represented, such as “category”, “post”, or “attachment”.

JSON data type: string

Context: view, edit, embed

object_id The database ID of the original object this menu item represents, for example the ID for posts or the term_id for categories.

JSON data type: integer

Context: view, edit, embed

target The target attribute of the link element for this menu item.

JSON data type: string

Context: view, edit, embed

One of: _blank,

url The URL to which this menu item points.

JSON data type: string,
Format: uri

Context: view, edit, embed

xfn The XFN relationship expressed in the link of this menu item.

JSON data type: array

Context: view, edit, embed

invalid Whether the menu item represents an object that no longer exists.

JSON data type: boolean

Read only

Context: view, edit, embed

menus The terms assigned to the object in the nav_menu taxonomy.

JSON data type: integer

Context: view, edit

meta Meta fields.

JSON data type: object

Context: view, edit

List Nav_Menu_Items

Query this endpoint to retrieve a collection of nav_menu_items. The response you receive can be controlled and filtered using the URL query parameters below.

Definition

GET /wp/v2/menu-items

Example Request

$ curl https://example.com/wp-json/wp/v2/menu-items

Arguments

context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

page Current page of the collection.

Default: 1

per_page Maximum number of items to be returned in result set.

Default: 100

search Limit results to those matching a string.
after Limit response to posts published after a given ISO8601 compliant date.
modified_after Limit response to posts modified after a given ISO8601 compliant date.
before Limit response to posts published before a given ISO8601 compliant date.
modified_before Limit response to posts modified before a given ISO8601 compliant date.
exclude Ensure result set excludes specific IDs.
include Limit result set to specific IDs.
offset Offset the result set by a specific number of items.
order Order sort attribute ascending or descending.

Default: asc

One of: asc, desc

orderby Sort collection by object attribute.

Default: menu_order

One of: author, date, id, include, modified, parent, relevance, slug, include_slugs, title, menu_order

search_columns Array of column names to be searched.
slug Limit result set to posts with one or more specific slugs.
status Limit result set to posts assigned one or more statuses.

Default: publish

tax_relation Limit result set based on relationship between multiple taxonomies.
One of: AND, OR
menus Limit result set to items with specific terms assigned in the menus taxonomy.
menus_exclude Limit result set to items except those with specific terms assigned in the menus taxonomy.
menu_order Limit result set to posts with a specific menu_order value.

Create a Nav_Menu_Item

Arguments

title The title for the object.
type The family of objects originally represented, such as “post_type” or “taxonomy”.

Default: custom

One of: taxonomy, post_type, post_type_archive, custom

status A named status for the object.

Default: publish

One of: publish, future, draft, pending, private

parent The ID for the parent of the object.
attr_title Text for the title attribute of the link element for this menu item.
classes Class names for the link element of this menu item.
description The description of this menu item.
menu_order The DB ID of the nav_menu_item that is this item’s menu parent, if any, otherwise 0.

Default: 1

object The type of object originally represented, such as “category”, “post”, or “attachment”.
object_id The database ID of the original object this menu item represents, for example the ID for posts or the term_id for categories.
target The target attribute of the link element for this menu item.
One of: _blank,
url The URL to which this menu item points.
xfn The XFN relationship expressed in the link of this menu item.
menus The terms assigned to the object in the nav_menu taxonomy.
meta Meta fields.

Definition

POST /wp/v2/menu-items

Retrieve a Nav_Menu_Item

Definition & Example Request

GET /wp/v2/menu-items/<id>

Query this endpoint to retrieve a specific nav_menu_item record.

$ curl https://example.com/wp-json/wp/v2/menu-items/<id>

Arguments

id Unique identifier for the post.
context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

Update a Nav_Menu_Item

Arguments

id Unique identifier for the post.
title The title for the object.
type The family of objects originally represented, such as “post_type” or “taxonomy”.
One of: taxonomy, post_type, post_type_archive, custom
status A named status for the object.
One of: publish, future, draft, pending, private
parent The ID for the parent of the object.
attr_title Text for the title attribute of the link element for this menu item.
classes Class names for the link element of this menu item.
description The description of this menu item.
menu_order The DB ID of the nav_menu_item that is this item’s menu parent, if any, otherwise 0.
object The type of object originally represented, such as “category”, “post”, or “attachment”.
object_id The database ID of the original object this menu item represents, for example the ID for posts or the term_id for categories.
target The target attribute of the link element for this menu item.
One of: _blank,
url The URL to which this menu item points.
xfn The XFN relationship expressed in the link of this menu item.
menus The terms assigned to the object in the nav_menu taxonomy.
meta Meta fields.

Definition

POST /wp/v2/menu-items/<id>

Example Request

Delete a Nav_Menu_Item

Arguments

id Unique identifier for the post.
force Whether to bypass Trash and force deletion.

Definition

DELETE /wp/v2/menu-items/<id>

Example Request

$ curl -X DELETE https://example.com/wp-json/wp/v2/menu-items/<id>

Nav_Menus

Schema

The schema defines all the fields that exist within a nav_menu record. Any response from these endpoints can be expected to contain the fields below unless the `_filter` query parameter is used or the schema field only appears in a specific context.

id Unique identifier for the term.

JSON data type: integer

Read only

Context: view, embed, edit

description HTML description of the term.

JSON data type: string

Context: view, edit

name HTML title for the term.

JSON data type: string

Context: view, embed, edit

slug An alphanumeric identifier for the term unique to its type.

JSON data type: string

Context: view, embed, edit

meta Meta fields.

JSON data type: object

Context: view, edit

locations The locations assigned to the menu.

JSON data type: array

Context: view, edit

auto_add Whether to automatically add top level pages to this menu.

JSON data type: boolean

Context: view, edit

List Nav_Menus

Query this endpoint to retrieve a collection of nav_menus. The response you receive can be controlled and filtered using the URL query parameters below.

Definition

GET /wp/v2/menus

Example Request

$ curl https://example.com/wp-json/wp/v2/menus

Arguments

context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

page Current page of the collection.

Default: 1

per_page Maximum number of items to be returned in result set.

Default: 10

search Limit results to those matching a string.
exclude Ensure result set excludes specific IDs.
include Limit result set to specific IDs.
offset Offset the result set by a specific number of items.
order Order sort attribute ascending or descending.

Default: asc

One of: asc, desc

orderby Sort collection by term attribute.

Default: name

One of: id, include, name, slug, include_slugs, term_group, description, count

hide_empty Whether to hide terms not assigned to any posts.
post Limit result set to terms assigned to a specific post.
slug Limit result set to terms with one or more specific slugs.

Create a Nav_Menu

Arguments

description HTML description of the term.
name HTML title for the term.

Required: 1

slug An alphanumeric identifier for the term unique to its type.
meta Meta fields.
locations The locations assigned to the menu.
auto_add Whether to automatically add top level pages to this menu.

Definition

POST /wp/v2/menus

Retrieve a Nav_Menu

Definition & Example Request

GET /wp/v2/menus/<id>

Query this endpoint to retrieve a specific nav_menu record.

$ curl https://example.com/wp-json/wp/v2/menus/<id>

Arguments

id Unique identifier for the term.
context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

Update a Nav_Menu

Arguments

id Unique identifier for the term.
description HTML description of the term.
name HTML title for the term.
slug An alphanumeric identifier for the term unique to its type.
meta Meta fields.
locations The locations assigned to the menu.
auto_add Whether to automatically add top level pages to this menu.

Definition

POST /wp/v2/menus/<id>

Example Request

Delete a Nav_Menu

Arguments

id Unique identifier for the term.
force Required to be true, as terms do not support trashing.

Definition

DELETE /wp/v2/menus/<id>

Example Request

$ curl -X DELETE https://example.com/wp-json/wp/v2/menus/<id>

Pattern Directory Items

Schema

The schema defines all the fields that exist within a pattern directory item record. Any response from these endpoints can be expected to contain the fields below unless the `_filter` query parameter is used or the schema field only appears in a specific context.

id The pattern ID.

JSON data type: integer

Context: view, edit, embed

title The pattern title, in human readable format.

JSON data type: string

Context: view, edit, embed

content The pattern content.

JSON data type: string

Context: view, edit, embed

categories The pattern’s category slugs.

JSON data type: array

Context: view, edit, embed

keywords The pattern’s keywords.

JSON data type: array

Context: view, edit, embed

description A description of the pattern.

JSON data type: string

Context: view, edit, embed

viewport_width The preferred width of the viewport when previewing a pattern, in pixels.

JSON data type: integer

Context: view, edit, embed

block_types The block types which can use this pattern.

JSON data type: array

Context: view, embed

List Pattern Directory Items

Query this endpoint to retrieve a collection of pattern directory items. The response you receive can be controlled and filtered using the URL query parameters below.

Definition

GET /wp/v2/pattern-directory/patterns

Example Request

$ curl https://example.com/wp-json/wp/v2/pattern-directory/patterns

Arguments

context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

page Current page of the collection.

Default: 1

per_page Maximum number of items to be returned in result set.

Default: 100

search Limit results to those matching a string.
category Limit results to those matching a category ID.
keyword Limit results to those matching a keyword ID.
slug Limit results to those matching a pattern (slug).
offset Offset the result set by a specific number of items.
order Order sort attribute ascending or descending.

Default: desc

One of: asc, desc

orderby Sort collection by post attribute.

Default: date

One of: author, date, id, include, modified, parent, relevance, slug, include_slugs, title, favorite_count

Sidebars

Schema

The schema defines all the fields that exist within a sidebar record. Any response from these endpoints can be expected to contain the fields below unless the `_filter` query parameter is used or the schema field only appears in a specific context.

id ID of sidebar.

JSON data type: string

Read only

Context: embed, view, edit

name Unique name identifying the sidebar.

JSON data type: string

Read only

Context: embed, view, edit

description Description of sidebar.

JSON data type: string

Read only

Context: embed, view, edit

class Extra CSS class to assign to the sidebar in the Widgets interface.

JSON data type: string

Read only

Context: embed, view, edit

before_widget HTML content to prepend to each widget’s HTML output when assigned to this sidebar. Default is an opening list item element.

JSON data type: string

Read only

Context: embed, view, edit

after_widget HTML content to append to each widget’s HTML output when assigned to this sidebar. Default is a closing list item element.

JSON data type: string

Read only

Context: embed, view, edit

before_title HTML content to prepend to the sidebar title when displayed. Default is an opening h2 element.

JSON data type: string

Read only

Context: embed, view, edit

after_title HTML content to append to the sidebar title when displayed. Default is a closing h2 element.

JSON data type: string

Read only

Context: embed, view, edit

status Status of sidebar.

JSON data type: string

Read only

Context: embed, view, edit

One of: active, inactive

widgets Nested widgets.

JSON data type: array

Context: embed, view, edit

Retrieve a Sidebar

Definition & Example Request

GET /wp/v2/sidebars

Query this endpoint to retrieve a specific sidebar record.

$ curl https://example.com/wp-json/wp/v2/sidebars

Arguments

context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

Retrieve a Sidebar

Definition & Example Request

GET /wp/v2/sidebars/<id>

Query this endpoint to retrieve a specific sidebar record.

$ curl https://example.com/wp-json/wp/v2/sidebars/<id>

Arguments

id The id of a registered sidebar
context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

Update a Sidebar

Arguments

widgets Nested widgets.

Definition

POST /wp/v2/sidebars/<id>

Example Request

Widget Types

Schema

The schema defines all the fields that exist within a widget type record. Any response from these endpoints can be expected to contain the fields below unless the `_filter` query parameter is used or the schema field only appears in a specific context.

id Unique slug identifying the widget type.

JSON data type: string

Read only

Context: embed, view, edit

name Human-readable name identifying the widget type.

JSON data type: string

Read only

Context: embed, view, edit

description Description of the widget.

JSON data type: string

Context: view, edit, embed

is_multi Whether the widget supports multiple instances

JSON data type: boolean

Read only

Context: view, edit, embed

classname Class name

JSON data type: string

Read only

Context: embed, view, edit

Retrieve a Widget Type

Definition & Example Request

GET /wp/v2/widget-types

Query this endpoint to retrieve a specific widget type record.

$ curl https://example.com/wp-json/wp/v2/widget-types

Arguments

context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

Retrieve a Widget Type

Definition & Example Request

GET /wp/v2/widget-types/<id>

Query this endpoint to retrieve a specific widget type record.

$ curl https://example.com/wp-json/wp/v2/widget-types/<id>

Arguments

id The widget type id.
context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

Widgets

Schema

The schema defines all the fields that exist within a widget record. Any response from these endpoints can be expected to contain the fields below unless the `_filter` query parameter is used or the schema field only appears in a specific context.

id Unique identifier for the widget.

JSON data type: string

Context: view, edit, embed

id_base The type of the widget. Corresponds to ID in widget-types endpoint.

JSON data type: string

Context: view, edit, embed

sidebar The sidebar the widget belongs to.

JSON data type: string

Context: view, edit, embed

rendered HTML representation of the widget.

JSON data type: string

Read only

Context: view, edit, embed

rendered_form HTML representation of the widget admin form.

JSON data type: string

Read only

Context: edit

instance Instance settings of the widget, if supported.

JSON data type: object

Context: edit

form_data URL-encoded form data from the widget admin form. Used to update a widget that does not support instance. Write only.

JSON data type: string

Context:

Retrieve a Widget

Definition & Example Request

GET /wp/v2/widgets

Query this endpoint to retrieve a specific widget record.

$ curl https://example.com/wp-json/wp/v2/widgets

Arguments

context Scope under which the request is made; determines fields present in response.

Default: view

One of: view, embed, edit

sidebar The sidebar to return widgets for.

Create a Widget

Arguments

id Unique identifier for the widget.
id_base The type of the widget. Corresponds to ID in widget-types endpoint.
sidebar The sidebar the widget belongs to.

Required: 1

Default: wp_inactive_widgets

instance Instance settings of the widget, if supported.
[...]
